local m = {}

function m.CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2, OldX,OldY)
	local Collisions = {}
	Collisions.Right = false
	Collisions.Left = false
	Collisions.Bottom = false
	Collisions.Top = false
	--[[ ATTEMPT 1
	Collisions.Right = (x1+w1 >= x2)and(OldX < x2)and(y1+h1 > y2)and(y1 < y2+h2)
	Collisions.Left = (x1 <= x2+w2)and(OldX > x2)and(y1+h1 > y2)and(y1 < y2+h2)
	Collisions.Bottom = (y1+h1 >= y2)and(OldY < y2)and(x1+w1 > x2)and(x1 < x2+w2)and(not Collisions.Right)and(not Collisions.Left)
	Collisions.Top = (y1 <= y2+h2)and(OldY > y2)and(x1+w1 > x2)and(x1 < x2+w2)and(not Collisions.Right)and(not Collisions.Left)
	--Collisions.Right = Collisions.Right and (not Collisions.Bottom) and (not Collisions.Top)
	--Collisions.Left = Collisions.Left and (not Collisions.Bottom) and (not Collisions.Top)
	--]]
	
	---[[ ATTEMPT 2 (LEAST BUGGY)
	
	if (x1+w1 > x2) and (x1 < x2+w2) then
		Collisions.Top = (OldY >= y2+h2) and (y1 <= y2+h2)
		Collisions.Bottom = (OldY+h1 <= y2) and (y1+h1 >= y2)
	end
	if (y1+h1 > y2) and (y1 < y2+h2) then
		Collisions.Left = (OldX >= x2+w2) and (x1 <= x2+w2)
		Collisions.Right = (OldX+w1 <= x2) and (x1+w1 >= x2)
	end
	--]]
	return (Collisions.Right or
	Collisions.Left or
	Collisions.Bottom or
	Collisions.Top), Collisions--{Collisions,GetDiff(x1,y1,w1,h1,x2,y2,w2,h2)}
end

return m
