local m = {}
m.Items = {}

local TilesetLoader = require("Assets_Scripts/TilesetLoader")

m.Items.Tiles = function() 
	return TilesetLoader.LoadTileset("Assets_Images/Tileset.png",32,32,24,24)
end



function m.Load()
	for k,v in pairs(m.Items)
		if type(v) == "function" then
			_G.Images[k] = v()
		else
			_G.Images[k] = love.graphics.newImage(v)
		end
	end
end
