local m = {}
local MusicConfig = require("Assets_Scripts/MusicConfig")

m.TargetMusic = ""
m.CurrentMusic = ""
m.BGM = MusicConfig[MusicConfig.Default]
m.BGM:setLooping(true)
m.BGM:play()

function m.ForceChangeMusic()
	m.BGM = MusicConfig[m.TargetMusic]
	m.CurrentMusic = m.TargetMusic
	m.BGM:setVolume(1)
	m.BGM:setLooping(true)
	m.BGM:stop()
	m.BGM:play()
end

function m.Update()
	if m.CurrentMusic ~= m.TargetMusic then
		local CurrentVol = m.BGM:getVolume()
		m.BGM:setVolume(math.max(0,CurrentVol - 0.02))
		if m.BGM:getVolume() <= 0 then
			m.ForceChangeMusic()
		end
	else
		if m.BGM:getVolume() ~= 1 then
			m.BGM:setVolume(1)
		end
	end
end

return m
