local m = {}

function m.LoadTileset(TilesetFile,TileW,TileH,TilesX,TilesY)
	local Template
	print(type(TilesetFile))
	if type(TilesetFile) == "userdata" then
		Template = TilesetFile
	else
		Template = love.image.newImageData(TilesetFile)
	end
	local Temp = {}
	local Final = {}
	for X=1,TilesX,1 do
		Final[X] = {}
		for Y=1,TilesY,1 do
			local TempKey = X.."_"..Y
			Temp[TempKey] = love.image.newImageData(TileW,TileH)
			Temp[TempKey]:paste(Template,0,0,TileW*(X-1),TileH*(Y-1),TileW,TileH)
			Final[X][Y] = love.graphics.newImage(Temp[TempKey])
			Temp[TempKey]:release()
			Temp[TempKey] = nil
		end
	end
	print("A")
	Template:release()
	print("A")
	return Final
end

return m
