local m = {}

function m.GetWorldTile(X,Y)
	local ChunkX = math.floor(X/32)
	local ChunkY = math.floor(Y/32)
	local TileX,TileY = m.WorldSpaceToChunkSpace(X,Y)
	return TileX,TileY,ChunkX,ChunkY
end

function m.WorldSpaceToChunkSpace(X,Y)
	local TileX = X%32
	local TileY = Y%32
	return TileX,TileY
end

function m.ChunkSpaceToWorldSpace(ChunkX,ChunkY,X,Y)
	TileX = X or 1
	TileY = Y or 1
	local FinalX = ChunkX*32
	local FinalY = ChunkY*32
	FinalX = FinalX + TileX
	FinalY = FinalY + TileY
	return FinalX,FinalY
end

return m
